#include <pspkernel.h>
#include <pspdisplay.h>
#include <pspdebug.h>
#include <pspgu.h>
#include <pspgum.h>
// ボール画像配列の参照
#include "ball.h"
#include "ball.psptex.h"
PSP_MODULE_INFO("balltex", PSP_MODULE_USER, 1, 1);
static unsigned int __attribute__((aligned(16))) list[262144];
#define BUF_WIDTH (512)
#define SCR_WIDTH (480)
#define SCR_HEIGHT (272)

typedef struct Vertex{
	unsigned short u, v;
	unsigned short color;
	short x, y, z;
}Vertex;
Vertex __attribute__((aligned(16))) squ[2]; // スクエア

// メインルーチン
int main() {
	pspDebugScreenInit();
	// gu初期化
	sceGuInit();
	sceGuStart(GU_DIRECT, list);
	sceGuDrawBuffer(GU_PSM_4444, (void*)0, BUF_WIDTH);
	sceGuDispBuffer(SCR_WIDTH, SCR_HEIGHT, (void*)0x44000, BUF_WIDTH);
	sceGuOffset(2048 - (SCR_WIDTH/2), 2048 - (SCR_HEIGHT/2));
	sceGuViewport(2048, 2048, SCR_WIDTH, SCR_HEIGHT);
	sceGuScissor(0, 0, SCR_WIDTH, SCR_HEIGHT);
	sceGuEnable(GU_SCISSOR_TEST);
	sceGuEnable(GU_TEXTURE_2D);
	sceGuFinish();
	sceGuSync(0, GU_SYNC_FINISH);
	sceDisplayWaitVblankStart();
	sceGuDisplay(GU_TRUE);
	while(1){
		// 描画開始＆テクスチャデータのセット
		sceGuStart(GU_DIRECT, list);
		sceGuTexMode(GU_PSM_4444, 0, 0, GU_FALSE);
		sceGuTexImage(0, 16, 16, 16, BALL_PSPTEX_0);
		sceGuTexFunc(GU_TFX_REPLACE, GU_TCC_RGBA);
		sceGuTexFilter(GU_NEAREST, GU_NEAREST); // GU_LINEAR指定でボカシ拡大
		// 表示座標セット。(x50,y50)-(x66,y66)の16x16等倍表示。終端まで自動拡大縮小される。
		squ[0].x = 50.0f; squ[0].y = 50.0f; squ[0].z = 0;
		squ[1].x = 66.0f; squ[1].y = 66.0f; squ[1].z = 0; 
		// u,v = テクスチャ全体のうち描画に用いる範囲([0].u , [0],v ) - ([1].u , [1].u)
		squ[0].u= 0; squ[0].v= 0;
		squ[1].u=15; squ[1].v=15;
		// GU_TRIANGLES、頂点2つ、構造体squを渡す。
		sceGuDrawArray(GU_SPRITES,GU_TEXTURE_16BIT|GU_COLOR_4444|GU_VERTEX_16BIT|GU_TRANSFORM_2D, 2, 0, squ);
		sceGuFinish(); sceGuSync(0,0); sceDisplayWaitVblankStart(); sceGuSwapBuffers();
	}
	return 0;
}
